<template>
  <div class="optionsContainer">
    <SortOptionButton text="BUBBLE" @click="bubbleSort"/>
    <SortOptionButton text="SELECTION" @click="selectionSort" />
    <SortOptionButton text="INSERTION" @click="insertionSort" />

  </div>
  <div class="visualizerContainer">
      <div class="original-array topBar">
        {{inputArray}}
      </div>

      <div class="visualizer">
        <!----
        ----->
        <div class="step-counter" style="smallBar">
          <div class="float-right">
            <button class="button button-outline">STEP: 1</button>
          </div>
        </div>
        <div class="graphic-visualizer">
          <GraphicVisualizer :outputArray="outputArray" />
        </div>
    </div>
  </div>
</template>

<script>
import SortOptionButton from "./SortOptionButton";
import GraphicVisualizer from "./GraphicVisualizer";

export default {
    name: 'VisualizerPanel',
    components: {
        SortOptionButton,
        GraphicVisualizer,
    },
    props: {
        outputArray: Array,
        inputArray: Array,
    },
    methods: {
        selectionSort(e) {
            e.preventDefault();
            this.$emit('selection-sort');
        },
        bubbleSort(e) {
            e.preventDefault();
            this.$emit('bubble-sort');
        },
        insertionSort(e) {
            e.preventDefault();
            this.$emit('insertion-sort');
        }
    },
}
</script>
    
<style scoped>
.palette {
  color: #121a21;
  color: #000000;
  color: #ff4c41;
  color: #c4d364;
  color: #ecce58;
  color: #40b2e1;
  color: #f5878b;
  color: #a3e9d4;
  color: #ffffff;
}
.optionsContainer {
  width: 300px;
  text-align: left;
  padding-top: 70px;
  padding-left: 100px;
  padding-right: 20px;
  top: 0px;
}

.visualizerContainer {
  position: absolute;
  right: 30px;
  width: calc(100% - 330px);
  height: 100%;
}
.visualizerContainer > div {
  display: inline-block;
}
.original-array {
  padding-top: 10px;
  text-align: center;
  color: white;
  height: 50px;
  background-color: #000;
  border-color: #fff;
  border-width: 0.01cm;
  border-radius: 0.2cm;
  border-style: solid;
  margin-bottom: 3px;
  width: 100%;
}
.step-counter > div > button {
  height: 48px;
  margin-right: 4px;
  margin-top: 4px;
  margin-bottom: 4px;
  padding: 0;
  width: 80px;
  height: 40px;
  color: black;
  border-color: #ecce58;
  border-style: hidden;
}
.graphic-visualizer {
  height: calc(100%);
  padding-bottom: 40px;
  width: 100%;
  display: flex;
  flex-direction: column;
}
.visualizer {
  height: calc(100% - 80px);
  width: 100%;
  background-color: #000;
  border-color: white;
  border-style: solid;
  border-width: 0.01cm;
  border-radius: 0.2cm;
  padding-bottom: 30px;
}
</style>